public class DC {
  
  private PileDeFlottants pile ;

  public DC () {
    pile = new PileDeFlottants(50) ;
  }

  public void entrer(float x) {
    pile.empiler(x) ;
  }

  public void entrer(char op) {
    float total ;
    switch (op) {
      case '+' : 
        total = pile.dpiler() ;
        total += pile.dpiler() ;
        pile.empiler(total) ;
        break ;
      case '-' :
        total = pile.dpiler() ;
        total = pile.dpiler() - total ;
        pile.empiler(total) ;
        break ;
      default :
        System.out.println("Opration non valide.") ;
    }
  }

  public void p() {
    System.out.println(pile.sommet()) ;
  }

  public void c() {
    pile.vider() ;
  }

  // Inverse l'ordre des deux dernieres valeurs entrees
  public void r() {
    if (pile.hauteur() < 2)
    {
      System.out.println("Moins de deux nombres sur la pile ; ne peut inverser.") ;
    }
    else
    {
      float top = pile.dpiler() ;
      float below = pile.dpiler() ;
      pile.empiler(top) ;
      pile.empiler(below) ;
    }
  }

  public void f() {
    pile.description() ;
  }
}
