public class PileDeFlottants {

  private int hauteurMax ;
  private float [] tableau ;
  private int hauteurPile ;

  public PileDeFlottants(int hauteurMax)  {
    // cre une pile vide
    this.hauteurMax = hauteurMax ;
    tableau = new float[hauteurMax] ;
    hauteurPile = 0 ;
  }

  public void empiler(float x)  {
    if (estSature())
    {
      System.out.println("Limite de contenance de la pile atteinte.\nRien ne sera empil.") ;
    }
    else
    {
      tableau[hauteurPile++] = x ;
    }
  }

  public float dpiler()  {
    if (estVide())
    {
      System.out.println("Rien  dpiler.") ;
      return -1.0f ;
    }
    else
    {
      return tableau[--hauteurPile] ;
    }
  }

  public float sommet()  {
    if (estVide())
    {
      System.out.println("Aucun flottant dans la pile") ;
      return -1.0f ;
    }
    else
    {
      return tableau[hauteurPile - 1] ;
    }
  }

  public int hauteur() {
    return hauteurPile ;
  }

  public int hauteurMax() {
    return hauteurMax ;
  }

  public boolean estSature() {
    return (hauteurPile >= hauteurMax) ;
  }

  public boolean estVide() {
    return (hauteurPile == 0) ;
  }

  public void vider() {
    hauteurPile = 0 ;
  }

  public void description() {
    System.out.println(hauteurPile + " lments :") ;
    int i ;
    for (i=hauteurPile - 1 ; i >= 0 ; i--)
    {
      System.out.println(tableau[i]) ;
    }
  }
}
