public class Lyumine {


// La partie prive :

  private String nom ;
  private boolean estJoyeux ;

  // rajoute pour l'exercice 2 : les 3 membres suivants :
  private Lyumine [] lyuminesConnus ;
  private int nbLyuminesConnus ;
  private static final int TAILLE_TABLEAU_LYUMINES_CONNUS = 20 ;


  private void ajouteConnaissanceLyumine(Lyumine L) {
    if (nbLyuminesConnus >= TAILLE_TABLEAU_LYUMINES_CONNUS)
    {
      System.out.println("Trop de lyumines connus ; boum bientot") ;
    }
    lyuminesConnus[nbLyuminesConnus] = L ;
    nbLyuminesConnus++ ;
  }

  private String presentation() {
    return new String(nom + " :  ") ;
  }


//==========================================

// Les mthodes publiques :


  public Lyumine (String nom) {
    this.nom = nom ;
    estJoyeux = true ;
    lyuminesConnus = new Lyumine[TAILLE_TABLEAU_LYUMINES_CONNUS] ;
    nbLyuminesConnus = 0 ;

    System.out.println("Bonjour ! Je viens de naitre, et je m'appelle " + nom) ;
  }

  public String nom () {
    return nom ;
  }

  public boolean estJoyeux () {
    return estJoyeux ;
  }

  public void sourire () {
    if (estJoyeux)
      System.out.println(presentation() + ":)") ;
  }

  public void apprendreQueEstNe(Lyumine L) {
    estJoyeux = true ;
    System.out.println(presentation() + ":) Bonjour " + L.nom() + " !") ;
    if (!connait(L))
      ajouteConnaissanceLyumine(L) ;
  }

  public boolean connait(Lyumine L) {
    if (L == this)
    {
      return true ;
    }
    else
    {
      int i ;
      boolean answer = false ;
      for (i=0 ; i<nbLyuminesConnus ; i++)
      {
        if (L == lyuminesConnus[i])
        {
          answer = true ;
          break ;
        }
      }
      return answer ;
    }
  }

  public void direLyuminesConnus() {
    int i ;
    System.out.println(presentation() + "Je connais :") ;
    for (i=0 ; i<nbLyuminesConnus ; i++)
    {
      System.out.println(lyuminesConnus[i].nom()) ;
    }
  }

  public void fairePresentationDesConnaissances() {
    int i, j ;
    // j'informe toutes mes connaissances que je suis ne :
    for (i=0 ; i<nbLyuminesConnus ; i++)
    {
      lyuminesConnus[i].apprendreQueEstNe(this) ;
    }

    // j'informe mes connaissances entre elles de leurs naissances :
    for (i=0 ; i<(nbLyuminesConnus - 1) ; i++)
    {
      for (j=i+1 ; j<nbLyuminesConnus ; j++)
      {
        lyuminesConnus[j].apprendreQueEstNe(lyuminesConnus[i]) ;
        lyuminesConnus[i].apprendreQueEstNe(lyuminesConnus[j]) ;
      }
    }
    /* Tous les appels dans cette methode
    a la methode "apprendreQueEstNe" utilisent le fait
    que celle-ci verifie, avant d'ajouter un lyumine
    aux connaissances, qu'il n'est pas deja connu.
    */
  }

	public String toString() {
		return nom ;
	}
}
