public class Lapin {

  // attributs et methodes de classe:

  private static int nbLapinsVivants = 0 ;    // initialise a 0 ;

  public static Lapin creerLapin(String s) {
    if (nbLapinsVivants < 50)
      return new Lapin(s) ;
    else
    {
      System.out.println(
          "Trop de lapins vivants. Pas de cration d'un nouveau lapin.") ;
      return null ;
    }
  }

  // =========================================

  // attributs et methodes d'objet :

  private String nom ;
  private boolean vivant ;

  /** constructeur declare en prive, avant que l'utilisateur de la classe
  Lapin soit oblige de passer par la methode de classe "creerLapin" pour creer
  un nouveau lapin.
  **/
  private Lapin (String s) {
    vivant = true ;
		nom = s ;
    System.out.println("Coucou ! Je suis un nouveau lapin, de nom : " + nom + " !") ;
    nbLapinsVivants++ ;
  }

  public void passeALaCasserole () {
    vivant = false ;
    nbLapinsVivants-- ;
  }
}
