class File {

  private Object [] tableau ;
  private int longueurMax ;

  private int indiceTete ;
  private int longueur ;

  /** cree une file vide, de taille bornee par N **/
  public File (int N) {
    longueurMax = N ;
    tableau = new Object[longueurMax] ;
    indiceTete = 0 ;
    longueur = 0 ;
  }

  public boolean estVide () {
    return (longueur == 0) ;
  }

  public int longueur () {
    return longueur ;
  }

  private int indiceQueue () {
    // ne marche que si la file n'est pas vide
    return (indiceTete + longueur - 1) % longueurMax ;
  }

  public void ajouterEnQueue (Object o) {
    if (longueur == longueurMax)
      System.out.println("File saturee. L'objet ne peut etre ajoute.") ;
    else
    {
      longueur ++ ;
      tableau[indiceQueue()] = o ;
    }
  }

  public Object tete () {
    if (longueur == 0)
    {
      System.out.println("Pas d'objets dans la queue.") ;
      return null ;
    }
    else
      return tableau[indiceTete] ;
  }

  public void supprimerTete () {
    if (longueur == 0)
      System.out.println("Pas d'objets dans la queue.") ;
    else
    {
      indiceTete = (indiceTete + 1) % longueurMax ;
      longueur-- ;
    }
  }
  
  public String toString () {
    String aRetourner = "" ;
    int i ;
    int indiceTeteCourant = indiceTete ;
    for (i = 0 ; i < longueur ; i++)
    {
      aRetourner += tableau[indiceTeteCourant].toString() + "\n";
      indiceTeteCourant = (indiceTeteCourant + 1) % longueurMax ;
    }
    return aRetourner ;
  }
}
