public class Liste {

  private Object elemTete ;
  private Liste     queue ;

  private Liste (Object o, Liste l) {
    elemTete = o ;
    queue    = l ;
  }

  public Liste () {    // cration d'une liste vide
    elemTete = null ;
    queue    = null ;
  }

  public Liste (Object o) {    // cration d'une liste  un lment
    elemTete = o ;
    queue    = new Liste () ;
// Choix d'implantation : si liste  un lment,
// alors liste vide en queue.
// Motif : cela simplifie le code d'une partie des mthodes.
  }

  public boolean estVide () {
    return (elemTete == null) ;
  }

  public Liste ajouterEnTete (Object o) {
    return new Liste (o, this) ;
  }

  public Object tete () {  
    if (estVide())
    {
      System.out.println("liste vide : pas de tete.\n") ;
      return null ;
    }
    else
      return elemTete ;
  }

  public Liste queue () {  
    if (estVide())
    {
      System.out.println("liste vide : pas de queue.\n") ;
      return null ;
    }
    else
      return queue ;
  }

  public String toString () {
    if (estVide())
      return "\n" ;
    else
      if (queue().estVide())
        return (tete().toString() + "\n") ;
      else
        return (tete().toString() + ",\n" + queue().toString()) ;
  }

  public int longueur () {
    if (estVide())
      return 0 ;
    else
      return 1 + queue().longueur() ;
  }


// Fin du code pour le TP 4
// Dbut du code pour le TP 5


  public boolean contient (Object o)
  {
    if (estVide())
      return false ;
    else
      return (o == elemTete || queue().contient(o)) ;
  }

  public Liste ajouterEnQueue (Object o) {
    if (estVide())
      return new Liste (o) ;
    else
      return new Liste (elemTete, queue.ajouterEnQueue(o)) ;
        // nouvelles listes :
        // pour ne pas modifier this.
  }
}
