// La classe Lyumine, modifie pour le TP 6 :

public class Lyumine {


// La partie prive :

	private String nom ;
	private boolean estJoyeux ;

	// rajoute pour l'exercice 2 : les 3 membres suivants :
	private Lyumine [] lyuminesConnus ;
	private int nbLyuminesConnus ;
	private static final int TAILLE_TABLEAU_LYUMINES_CONNUS = 20 ;

	// rajoute pour le TP 6 : les 3 membres suivants :

	private Maison maison ;
	private Lieu lieuCourant ;

	private boolean invitant ;
			        // utilise pour les invitations, afin d'eviter les bouclages


  private void ajouteConnaissanceLyumine(Lyumine L) {
		if (nbLyuminesConnus >= TAILLE_TABLEAU_LYUMINES_CONNUS)
		{
			System.out.println("Trop de lyumines connus ; boum bientot") ;
		}
		lyuminesConnus[nbLyuminesConnus] = L ;
		nbLyuminesConnus++ ;
	}

	private String presentation() {
		return new String(nom + " :  ") ;
	}


//==========================================

// Les mthodes publiques :


  public Lyumine (String nom) {
		this.nom = nom ;
		estJoyeux = true ;
		lyuminesConnus = new Lyumine[TAILLE_TABLEAU_LYUMINES_CONNUS] ;
		nbLyuminesConnus = 0 ;

		System.out.println("Bonjour ! Je viens de naitre, et je m'appelle " + nom) ;
	}

	public String nom () {
		return nom ;
	}

	public boolean estJoyeux () {
		return estJoyeux ;
	}

  public void sourire () {
		if (estJoyeux)
			System.out.println(presentation() + ":)") ;
	}

	public void apprendreQueEstNe(Lyumine L) {
		estJoyeux = true ;
		System.out.println(presentation() + ":) Bonjour " + L.nom() + " !") ;
		if (!connait(L))
			ajouteConnaissanceLyumine(L) ;
	}

	public boolean connait(Lyumine L) {
		if (L == this)
		{
			return true ;
		}
		else
		{
			int i ;
			boolean answer = false ;
			for (i=0 ; i<nbLyuminesConnus ; i++)
			{
				if (L == lyuminesConnus[i])
				{
					answer = true ;
					break ;
				}
			}
			return answer ;
		}
	}

	public void direLyuminesConnus() {
		int i ;
		System.out.println(presentation() + "Je connais :") ;
		for (i=0 ; i<nbLyuminesConnus ; i++)
		{
			System.out.println(lyuminesConnus[i].nom()) ;
		}
	}

  public void fairePresentationDesConnaissances() {
		int i, j ;
		// j'informe toutes mes connaissances que je suis ne :
		for (i=0 ; i<nbLyuminesConnus ; i++)
		{
			lyuminesConnus[i].apprendreQueEstNe(this) ;
		}

		// j'informe mes connaissances entre elles de leurs naissances :
		for (i=0 ; i<(nbLyuminesConnus - 1) ; i++)
		{
			for (j=i+1 ; j<nbLyuminesConnus ; j++)
			{
				lyuminesConnus[j].apprendreQueEstNe(lyuminesConnus[i]) ;
				lyuminesConnus[i].apprendreQueEstNe(lyuminesConnus[j]) ;
			}
		}
		/* Tous les appels dans cette methode
		a la methode "apprendreQueEstNe" utilisent le fait
		que celle-ci verifie, avant d'ajouter un lyumine
		aux connaissances, qu'il n'est pas deja connu.
		*/
	}


	// =========================================
	// Les methodes pour le TP 6 :


	public void habiter(Maison m) {
		maison = m ;
	}

	public void direOuHabite() {
		System.out.println(presentation() + "J'habite dans la maison " 
			+ maison.nom()) ;
	}

	public void allerDansLieu (Lieu unLieu) {
		lieuCourant = unLieu ;
	}

	public void direOuEst () {
		System.out.println(presentation() + "Je suis a : " 
			+ lieuCourant.nom()) ;
	}

	public void inviterPourUnThe(Lyumine L) {
		estJoyeux = true ;
		invitant = true ;
		L.etreInvitePourUnThePar(this) ;
		invitant = false ;

		lieuCourant = maison ;
	}

	public void inviterConnaissancesPourUnThe() {
		invitant = true ;
		int i ;
		for (i=0 ; i < nbLyuminesConnus ; i++)
		{
			lyuminesConnus[i].etreInvitePourUnThePar(this) ;
		}
		invitant = false ;
	}

	public void etreInvitePourUnThePar(Lyumine L) {
					/* dans le corps de cette methode,
					la manipulation de l'attribut "invitant" permet
					d'eviter les bouclage - que celui qui invite
					ne soit invite par un de ceux qu'il invitent, et se
					remette a inviter toutes ses connaissances, et ainsi de suite.
					*/

		invitant = true ;
		int i ;
		for (i=0 ; i < nbLyuminesConnus ; i++)
		{
			Lyumine connaissance = lyuminesConnus[i] ;
			if (!connaissance.invitant)
			{
				connaissance.etreInvitePourUnThePar(L) ;
			}
		}
		invitant = false ;
		lieuCourant = L.maison() ;
	}

	public Maison maison() {
		if (maison == null)
		{
			System.out.println(presentation() + "Je n'ai pas de maison") ;
			return null ;
		}
		else
		{
			return maison ;
		}
	}

	public Lieu lieu() {
		return lieuCourant ;
	}
}
